//
// spamodo: spamassassin/qmail-local integration tool
//

// Copyright (c) 2004 Dean Gaudet <dean@arctic.org>
// 
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software"),
// to deal in the Software without restriction, including without limitation
// the rights to use, copy, modify, merge, publish, distribute, sublicense,
// and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

// $Id: spamodo.c,v 1.2 2005/01/12 10:10:35 dean Exp $

#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>
#include <signal.h>
#include <stdlib.h>
#include <sysexits.h>

#define TMP		"/tmp"
#define QMAIL_LOCAL	"/var/qmail/bin/qmail-local"

static char *spamc_argv[] = {
	"/usr/bin/spamc", "-U", "/var/run/spamd/sock", NULL
};

#define EX_TEMP_FAIL	(111)

int main(int argc, char **argv)
{
	char filtered_filename[] = TMP "/spamodo.XXXXXX";
	int filtered_fd;
	pid_t child_pid;
	int child_status;

	if ((filtered_fd = mkstemp(filtered_filename)) == -1) goto qmail;
	unlink(filtered_filename);
	child_pid = fork();
	if (child_pid == -1) goto qmail;
	if (child_pid == 0) {
		if (dup2(filtered_fd, 1) == -1) exit(EX_OSERR);
		close(2); open("/dev/null", O_RDONLY);
		execv(spamc_argv[0], spamc_argv);
		exit(EX_OSERR);
	}
	if (waitpid(child_pid, &child_status, 0) != -1
		&& WIFEXITED(child_status)
		&& WEXITSTATUS(child_status) == 0) {
		// success or fail doesn't matter...
		dup2(filtered_fd, 0);
	}
	// is this required?
	lseek(0, 0, SEEK_SET);
qmail:
	argv[0] = getenv("SPAMODOLOCAL");
	if (argv[0] == NULL) argv[0] = QMAIL_LOCAL;
	execv(argv[0], argv);
	exit(EX_TEMP_FAIL);
}
